unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    rhoEdit: TLabeledEdit;
    sumEdit: TLabeledEdit;
    KcalcBtn: TBitBtn;
    kEdit: TLabeledEdit;
    CdEdit: TLabeledEdit;
    GroupBox2: TGroupBox;
    mEdit: TLabeledEdit;
    tEdit: TLabeledEdit;
    gEdit: TLabeledEdit;
    vhBtn: TBitBtn;
    V0Edit: TLabeledEdit;
    Memo1: TMemo;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Chart2: TChart;
    Series3: TLineSeries;
    Series4: TLineSeries;
    jEdit: TLabeledEdit;
    CheckBox1: TCheckBox;
    procedure KcalcBtnClick(Sender: TObject);
    procedure vhBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure down(v0, t, k, m, g: extended; j: integer);
    procedure downN(v0, t, k, m, g: extended; j: integer);
    procedure Horizontal(v0, t, k, m: extended; j: integer);
    procedure HorizontalN(v0, t, k, m: extended; j: integer);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
// CR͌WCRvZkg/mvZ
procedure TForm1.KcalcBtnClick(Sender: TObject);
var
  k   : extended;   // CRW  kg/m
  Cd  : extended;   // CR͌W
  r   : extended;   // Cx   kg/m^3
  S   : extended;   // \ʐ   m^2
  ch  : integer;
begin
  val(CdEdit.Text, Cd, ch);
  if ch <> 0 then begin
    Memo1.Text := 'Cd:CR͌WɊԈႢ܂B';
    exit;
  end;
  val(rhoEdit.Text, r, ch);
  if ch <> 0 then begin
    Memo1.Text := ':CxɊԈႢ܂B';
    exit;
  end;
  val(sumEdit.Text, S, ch);
  if ch <> 0 then begin
    Memo1.Text := 'S:\ʐςɊԈႢ܂B';
    exit;
  end;
  k := Cd * r * s / 2;
  kEdit.Text := floatTostr(k);
end;

//  ␳L
procedure TForm1.HorizontalN(v0, t, k, m: extended; j: integer);
var
  dv, dt, mdg, fv : extended;
  ndv, nmdg : extended;
  ti : extended;
  l,  v : extended;
  i: Integer;
begin
  series3.Clear;
  series4.Clear;
  l := 0;
  fv := 0;
  v := abs(v0);
  dt := t / j;
  series3.AddXY(0 , v);
  series4.AddXY(0 , l);
  for i := 1 to j do begin
    ti := i * dt;                  // 
    dv := v * v * k;               // R
    mdg := dv / m;                 // x
    fv := v - mdg * dt;            // \x
    ndv := fv * fv * k;            // \R
    nmdg := ndv / m;               // \x
    mdg := (mdg + nmdg) / 2;       // ωx
    fv := v - mdg * dt;            // Vx
    if fv < 0 then break;
    l := l + (v + fv) / 2 * dt;    // 
    v := fv;
    series3.AddXY(ti , v);
    series4.AddXY(ti , l);
  end;
  if fv < 0 then begin
    memo1.Lines.Append('VvZ sAԂ׌vZo܂B');
    exit;
  end;
  memo1.Lines.Append('Vx ' + floatTostr(v) + ' m/s');
  memo1.Lines.Append('V ' + floatTostr(l) + ' m');
end;

//  ␳
procedure TForm1.Horizontal(v0, t, k, m: extended; j: integer);
var
  dv, dt, mdg, fv : extended;
  ti : extended;
  l,  v : extended;
  i: Integer;
begin
  series1.Clear;
  series2.Clear;
  l := 0;
  fv := 0;
  v := abs(v0);
  dt := t / j;
  series1.AddXY(0 , v);
  series2.AddXY(0 , l);
  for i := 1 to j do begin
    ti := i * dt;                  // 
    dv := v * v * k;               // R
    mdg := dv / m;                 // x
    fv := v - mdg * dt;            // x
    if fv < 0 then break;
    l := l + (v + fv) / 2 * dt;    // 
    v := fv;                       // Vx
    series1.AddXY(ti , v);
    series2.AddXY(ti , l);
  end;
  if fv < 0 then begin
    memo1.Lines.Append('VvZ sAԂ׌vZo܂B');
    exit;
  end;
  memo1.Lines.Append('x ' + floatTostr(v) + ' m/s');
  memo1.Lines.Append(' ' + floatTostr(l) + ' m');
end;

// ~  ␳
procedure TForm1.down(v0, t, k, m, g: extended; j: integer);
var
  vmax, ti : extended;
  h, v: extended;
  dv, dm, dt, mdg, fv : extended;
  i :  integer;
begin
  series1.Clear;
  series2.Clear;
  h := 0;
  dt := t / j;                      // t
  v := -v0;
  fv := 0;
  vmax := sqrt(m * g / k);          // tx
  dm := vmax * vmax * k;            // tR
  series1.AddXY(0 , -v);
  series2.AddXY(0 , -h);
  for i := 1 to j do begin
    ti := i * dt;                   // 
    dv := v * v * k;                // R
    mdg := (dv - dm) / m;           // x
    fv := v - mdg * dt;             // 
    if fv < 0 then break;
    h := h + (v + fv) / 2 * dt;     //  + ϑx*
    v := fv;                        // Vx
    series1.AddXY(ti , -v);
    series2.AddXY(ti , -h);
  end;
  if fv < 0 then begin
    memo1.Lines.Append('vZ sAԂ׌vZo܂B');
    exit;
  end;
  memo1.Lines.Append('x ' + floatTostr(-v) + ' m/s');
  memo1.Lines.Append(' ' + floatTostr(-h) + ' m');
end;

// ~ ␳L
procedure TForm1.downN(v0, t, k, m, g: extended; j: integer);
var
  vmax, ti : extended;
  h, v: extended;
  dv, dm, dt, mdg, fv : extended;
  ndv, nmdg : extended;
  im, itwo : extended;
  i : integer;
begin
  series3.Clear;
  series4.Clear;
  im := 1 / m;
  itwo := 1 / 2;
  h := 0;
  dt := t / j;                      // t
  v := -v0;
  fv := 0;
  vmax := sqrt(m * g / k);          // tx
  dm := vmax * vmax * k;            // tR
  series3.AddXY(0 , -v);
  series4.AddXY(0 , -h);
  for i := 1 to j do begin
    ti := i * dt;
    dv := v * v * k;                // R
    mdg := (dv - dm) * im;          // x
    fv := v - mdg * dt;             // \
    ndv := fv * fv * k;             // \R
    nmdg := (ndv - dm) * im;        // \x
    mdg := (nmdg + mdg) * itwo;     // ωx
    fv := v - mdg * dt;             // 
    if fv < 0 then break;
    h := h + (fv + v) * itwo * dt;  //  + ϑx*
    v := fv;                        // Vx
    series3.AddXY(ti , -v);
    series4.AddXY(ti , -h);
  end;
  if fv < 0 then begin
    memo1.Lines.Append('VvZ sAԂ׌vZo܂B');
    exit;
  end;
  memo1.Lines.Append('Vx ' + floatTostr(-v) + ' m/s');
  memo1.Lines.Append('V ' + floatTostr(-h) + ' m');
end;

// vhvZs
procedure TForm1.vhBtnClick(Sender: TObject);
var
  k   : extended;   // CRW  kg/m
  m   : extended;   //           kg
  t   : extended;   //       sec
  g   : extended;   // d͉x    m/sec^2
  v0  : extended;   // x        m/s
  ch  : integer;
  j   : integer;
begin
  Memo1.Clear;
  val(kEdit.Text, k, ch);
  if ch <> 0 then begin
    Memo1.Text := 'k:CRWɊԈႢ܂B';
    exit;
  end;
  if k <= 0 then begin
    Memo1.Text := 'k:CRW̒l0([)傫ĂB';
    exit;
  end;
  val(mEdit.Text, m, ch);
  if ch <> 0 then begin
    Memo1.Text := 'm:ʂɊԈႢ܂B';
    exit;
  end;
  if m <= 0 then begin
    Memo1.Text := 'm:ʂ̒l0([)傫ĂB';
    exit;
  end;
  val(tEdit.Text, t, ch);
  if ch <> 0 then begin
    Memo1.Text := 't:ԂɊԈႢ܂B';
    exit;
  end;
  if t <= 0 then begin
    Memo1.Text := 't:Ԃ̒l0([)傫ĂB';
    exit;
  end;
  val(gEdit.Text, g, ch);
  if ch <> 0 then begin
    Memo1.Text := 'g:xɊԈႢ܂B';
    exit;
  end;
  if g <= 0 then begin
    Memo1.Text := 'g:x̒l0([)傫ĂB';
    exit;
  end;
  val(v0Edit.Text, v0, ch);
  if ch <> 0 then begin
    Memo1.Text := 'V0:xɊԈႢ܂B';
    exit;
  end;
  val(jEdit.Text, j, ch);
  if ch <> 0 then begin
    Memo1.Text := 'j:ɊԈႢ܂B';
    exit;
  end;
  if j <= 2 then begin
    Memo1.Text := 'j:2傫ĂB';
    exit;
  end;
  if j > 10000000 then begin
    Memo1.Text := 'j:傫܂B';
    exit;
  end;
  memo1.Clear;
  if checkbox1.Checked = false then begin
    down(v0, t, k, m, g, j);
    downN(v0, t, k, m, g, j);
  end
  else begin
    Horizontal(v0, t, k, m, j);
    HorizontalN(v0, t, k, m, j);
  end;
end;

end.
